---
title: Read External Authentication Initialization
description: The GET /{{envID}}/rp/authenticate?providerId={{idpID}}&flowId={{flowID}} endpoint creates a new external authentication with an identity provider. It redirects users to the authentication initialization endpoint at the external authentication service.
component: pingone-api
page_id: pingone-api:auth:external-authentication/read-external-authentication-initialization
canonical_url: https://developer.pingidentity.com/pingone-api/auth/external-authentication/read-external-authentication-initialization.html
section_ids:
  example-request: Example Request
  example-response: Example Response
---

# Read External Authentication Initialization

##

```none
GET {{authPath}}/{{envID}}/rp/authenticate?providerId={{idpID}}&flowId={{flowID}}
```

The `GET /{{envID}}/rp/authenticate?providerId={{idpID}}&flowId={{flowID}}` endpoint creates a new external authentication with an identity provider. It redirects users to the authentication initialization endpoint at the external authentication service.

|   |                                                                                                                                                                                                            |
| - | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|   | There is a 15-minute timeout for completing the external authentication. If external authentication at the identity provider is not completed in that time, the redirect back to `/rp/callback` will fail. |

> **Collapse: Query parameters**
>
> | Parameter    | Description                                                                                                                                                                  |
> | ------------ | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
> | `acrValues`  | The authentication context references values that will be sent to the IDPs that support this. This has the same semantics as the `acr_values` parameter from OpenID Connect. |
> | `flowId`     | A string that specifies the ID of the flow resource.                                                                                                                         |
> | `loginHint`  | A string that specifies the login hint provided by the user. This parameter has the same semantics as the `login_hint` parameter from OpenID Connect.                        |
> | `providerId` | A string that specifies the ID of the identity provider.                                                                                                                     |

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff '{{authPath}}/{{envID}}/rp/authenticate?providerId={{idpID}}&flowId={{flowID}}'
```

```csharp
var options = new RestClientOptions("{{authPath}}/{{envID}}/rp/authenticate?providerId={{idpID}}&flowId={{flowID}}")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Get);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "net/http"
  "io"
)

func main() {

  url := "{{authPath}}/{{envID}}/rp/authenticate?providerId={{idpID}}&flowId={{flowID}}"
  method := "GET"

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, nil)

  if err != nil {
    fmt.Println(err)
    return
  }
  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
GET /{{envID}}/rp/authenticate?providerId={{idpID}}&flowId={{flowID}} HTTP/1.1
Host: {{authPath}}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("text/plain");
RequestBody body = RequestBody.create(mediaType, "");
Request request = new Request.Builder()
  .url("{{authPath}}/{{envID}}/rp/authenticate?providerId={{idpID}}&flowId={{flowID}}")
  .method("GET", body)
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{authPath}}/{{envID}}/rp/authenticate?providerId={{idpID}}&flowId={{flowID}}",
  "method": "GET",
  "timeout": 0,
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'GET',
  'url': '{{authPath}}/{{envID}}/rp/authenticate?providerId={{idpID}}&flowId={{flowID}}',
  'headers': {
  }
};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests

url = "{{authPath}}/{{envID}}/rp/authenticate?providerId={{idpID}}&flowId={{flowID}}"

payload = {}
headers = {}

response = requests.request("GET", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{authPath}}/{{envID}}/rp/authenticate?providerId={{idpID}}&flowId={{flowID}}');
$request->setMethod(HTTP_Request2::METHOD_GET);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "net/http"

url = URI("{{authPath}}/{{envID}}/rp/authenticate?providerId={{idpID}}&flowId={{flowID}}")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Get.new(url)

response = http.request(request)
puts response.read_body
```

```swift
var request = URLRequest(url: URL(string: "{{authPath}}/{{envID}}/rp/authenticate?providerId={{idpID}}&flowId={{flowID}}")!,timeoutInterval: Double.infinity)
request.httpMethod = "GET"

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

302 Found
